package org.omg.PortableServer;

import org.omg.PortableServer.POAPackage.WrongAdapter;
import org.omg.PortableServer.POAPackage.ServantNotActive;
import org.omg.CORBA.Object;
import org.omg.PortableServer.POAPackage.ObjectNotActive;
import org.omg.PortableServer.POAPackage.ObjectAlreadyActive;
import org.omg.PortableServer.POAPackage.ServantAlreadyActive;
import org.omg.PortableServer.POAPackage.NoServant;
import org.omg.PortableServer.POAPackage.WrongPolicy;
import org.omg.PortableServer.POAPackage.AdapterNonExistent;
import org.omg.PortableServer.POAPackage.InvalidPolicy;
import org.omg.PortableServer.POAPackage.AdapterAlreadyExists;
import org.omg.CORBA.Policy;

public interface POAOperations
{
    public abstract POA create_POA(String p0, POAManager p1, Policy[] p2) throws AdapterAlreadyExists, InvalidPolicy;
    
    public abstract POA find_POA(String p0, boolean p1) throws AdapterNonExistent;
    
    public abstract void destroy(boolean p0, boolean p1);
    
    public abstract ThreadPolicy create_thread_policy(ThreadPolicyValue p0);
    
    public abstract LifespanPolicy create_lifespan_policy(LifespanPolicyValue p0);
    
    public abstract IdUniquenessPolicy create_id_uniqueness_policy(IdUniquenessPolicyValue p0);
    
    public abstract IdAssignmentPolicy create_id_assignment_policy(IdAssignmentPolicyValue p0);
    
    public abstract ImplicitActivationPolicy create_implicit_activation_policy(ImplicitActivationPolicyValue p0);
    
    public abstract ServantRetentionPolicy create_servant_retention_policy(ServantRetentionPolicyValue p0);
    
    public abstract RequestProcessingPolicy create_request_processing_policy(RequestProcessingPolicyValue p0);
    
    public abstract String the_name();
    
    public abstract POA the_parent();
    
    public abstract POA[] the_children();
    
    public abstract POAManager the_POAManager();
    
    public abstract AdapterActivator the_activator();
    
    public abstract void the_activator(AdapterActivator p0);
    
    public abstract ServantManager get_servant_manager() throws WrongPolicy;
    
    public abstract void set_servant_manager(ServantManager p0) throws WrongPolicy;
    
    public abstract Servant get_servant() throws NoServant, WrongPolicy;
    
    public abstract void set_servant(Servant p0) throws WrongPolicy;
    
    public abstract byte[] activate_object(Servant p0) throws ServantAlreadyActive, WrongPolicy;
    
    public abstract void activate_object_with_id(byte[] p0, Servant p1) throws ServantAlreadyActive, ObjectAlreadyActive, WrongPolicy;
    
    public abstract void deactivate_object(byte[] p0) throws ObjectNotActive, WrongPolicy;
    
    public abstract org.omg.CORBA.Object create_reference(String p0) throws WrongPolicy;
    
    public abstract org.omg.CORBA.Object create_reference_with_id(byte[] p0, String p1);
    
    public abstract byte[] servant_to_id(Servant p0) throws ServantNotActive, WrongPolicy;
    
    public abstract org.omg.CORBA.Object servant_to_reference(Servant p0) throws ServantNotActive, WrongPolicy;
    
    public abstract Servant reference_to_servant(org.omg.CORBA.Object p0) throws ObjectNotActive, WrongPolicy, WrongAdapter;
    
    public abstract byte[] reference_to_id(org.omg.CORBA.Object p0) throws WrongAdapter, WrongPolicy;
    
    public abstract Servant id_to_servant(byte[] p0) throws ObjectNotActive, WrongPolicy;
    
    public abstract org.omg.CORBA.Object id_to_reference(byte[] p0) throws ObjectNotActive, WrongPolicy;
    
    public abstract byte[] id();
}
